import { isUndefined } from 'lodash';
import { useRef } from 'react';
import { useAsync, useEvent, useRefExtra } from '@react-devui/hooks';
import { cloneHTMLElement } from '../../utils';
const FOCUS_KEY = ['ArrowUp', 'ArrowDown', 'ArrowLeft', 'ArrowRight', 'Home', 'End', 'Enter', 'Space'];
export function DFocusVisible(props) {
    const { children, dDisabled = false, onFocusVisibleChange } = props;
    //#region Ref
    const windowRef = useRefExtra(() => window);
    //#endregion
    const dataRef = useRef({});
    const async = useAsync();
    useEvent(windowRef, 'keydown', () => {
        var _a, _b;
        (_b = (_a = dataRef.current).clearTid) === null || _b === void 0 ? void 0 : _b.call(_a);
        dataRef.current.clearTid = async.setTimeout(() => {
            dataRef.current.clearTid = undefined;
        }, 20);
    }, {}, dDisabled);
    return children({
        render: (el) => dDisabled
            ? el
            : cloneHTMLElement(el, {
                onFocus: (e) => {
                    var _a, _b;
                    (_b = (_a = el.props).onFocus) === null || _b === void 0 ? void 0 : _b.call(_a, e);
                    if (!isUndefined(dataRef.current.clearTid)) {
                        onFocusVisibleChange(true);
                    }
                },
                onBlur: (e) => {
                    var _a, _b;
                    (_b = (_a = el.props).onBlur) === null || _b === void 0 ? void 0 : _b.call(_a, e);
                    onFocusVisibleChange(false);
                },
                onKeyDown: (e) => {
                    var _a, _b;
                    (_b = (_a = el.props).onKeyDown) === null || _b === void 0 ? void 0 : _b.call(_a, e);
                    if (FOCUS_KEY.includes(e.code)) {
                        onFocusVisibleChange(true);
                    }
                },
            }),
    });
}
