var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import { isFunction } from 'lodash';
import { useState } from 'react';
import { useId } from '@react-devui/hooks';
import { StarFilled } from '@react-devui/icons';
import { checkNodeExist, getClassName } from '@react-devui/utils';
import { useGeneralContext, useDValue } from '../../hooks';
import { registerComponentMate } from '../../utils';
import { useFormControl } from '../form';
import { useComponentConfig, usePrefixConfig } from '../root';
import { DStar } from './Star';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DRating' });
export function DRating(props) {
    const _a = useComponentConfig(COMPONENT_NAME, props), { dFormControl, dModel, dName, dDisabled = false, dTotal = 5, dHalf = false, dReadOnly = false, dCustomIcon, dTooltip, onModelChange } = _a, restProps = __rest(_a, ["dFormControl", "dModel", "dName", "dDisabled", "dTotal", "dHalf", "dReadOnly", "dCustomIcon", "dTooltip", "onModelChange"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    const { gDisabled } = useGeneralContext();
    //#endregion
    const uniqueId = useId();
    const [hoverValue, setHoverValue] = useState(null);
    const formControlInject = useFormControl(dFormControl);
    const [value, changeValue] = useDValue(null, dModel, onModelChange, undefined, formControlInject);
    const disabled = dDisabled || gDisabled || (dFormControl === null || dFormControl === void 0 ? void 0 : dFormControl.control.disabled);
    return (_jsx("div", Object.assign({}, restProps, { className: getClassName(restProps.className, `${dPrefix}rating`, {
            [`${dPrefix}rating--read-only`]: dReadOnly,
            'is-disabled': disabled,
        }), role: "radiogroup", onMouseLeave: (e) => {
            var _a;
            (_a = restProps.onMouseLeave) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
            setHoverValue(null);
        } }, { children: Array.from({ length: dTotal }).map((_, i) => (_jsx(DStar, { dFormControl: dFormControl, dName: dName !== null && dName !== void 0 ? dName : uniqueId, dDisabled: disabled || dReadOnly, dValue: i + 1, dIcon: isFunction(dCustomIcon) ? dCustomIcon(i + 1) : checkNodeExist(dCustomIcon) ? dCustomIcon : _jsx(StarFilled, {}), dChecked: value, dHoverValue: hoverValue, dHalf: dHalf, dTooltip: dTooltip, onCheck: (v) => changeValue(v), onHoverChange: (v) => setHoverValue(v) }, i + 1))) })));
}
